explain_wait3(3)

NAME
explain_wait3 - explain wait3(2) errors

SYNOPSIS
#include <libexplain/wait3.h>

const char *explain_wait3(int *status, int options, struct rusage *rusage);
const char *explain_errno_wait3(int errnum, int *status, int options, struct rusage *rusage);
void explain_message_wait3(char *message, int message_size, int *status, int options, struct rusage *rusage);
void explain_message_errno_wait3(char *message, int message_size, int errnum, int *status, int options, struct rusage *rusage);

DESCRIPTION
These functions may be used to obtain explanations for errors returned by the wait3(2) system call.

  explain_wait3
const char *explain_wait3(int *status, int options, struct rusage *rusage);

The explain_wait3 function is used to obtain an explanation of an error returned by the wait3(2) system call. The least the message will contain is the value of strerror(errno), but usually it will do much better, and indicate the underlying cause in more detail.

The errno global variable will be used to obtain the error value to be decoded.

This function is intended to be used in a fashion similar to the following example:
    int pid = wait3(status, options, rusage);
    if (pid < 0)
    {
        fprintf(stderr, "%s\n", explain_wait3(status, options, rusage));
        exit(EXIT_FAILURE);
    }

status
    The original status, exactly as passed to the wait3(2) system call.

options
    The original options, exactly as passed to the wait3(2) system call.

rusage
    The original rusage, exactly as passed to the wait3(2) system call.

Returns:
    The message explaining the error. This message buffer is shared by all libexplain functions which do not supply a buffer in their argument list. This will be overwritten by the next call to any libexplain function which shares this buffer, including other threads.

Note: This function is not thread safe, because it shares a return buffer across all threads, and many other functions in this library.

  explain_errno_wait3
const char *explain_errno_wait3(int errnum, int *status, int options, struct rusage *rusage);

The explain_errno_wait3 function is used to obtain an explanation of an error returned by the wait3(2) system call. The least the message will contain is the value of strerror(errnum), but usually it will do much better, and indicate the underlying cause in more detail.

This function is intended to be used in a fashion similar to the following example:
    int pid = wait3(status, options, rusage);
    if (pid < 0)
    {
        int err = errno;
        fprintf(stderr, "%s\n", explain_errno_wait3(err, status, options,
            rusage));
        exit(EXIT_FAILURE);
    }

errnum
    The error value to be decoded, usually obtained from the errno global variable just before this function is called. This is necessary if you need to call any code between the system call to be explained and this function, because many libc functions will alter the value of errno.

status
    The original status, exactly as passed to the wait3(2) system call.

options
    The original options, exactly as passed to the wait3(2) system call.

rusage
    The original rusage, exactly as passed to the wait3(2) system call.

Returns:
    The message explaining the error. This message buffer is shared by all libexplain functions which do not supply a buffer in their argument list. This will be overwritten by the next call to any libexplain function which shares this buffer, including other threads.

Note: This function is not thread safe, because it shares a return buffer across all threads, and many other functions in this library.

  explain_message_wait3
void explain_message_wait3(char *message, int message_size, int *status, int options, struct rusage *rusage);

The explain_message_wait3 function may be used to obtain an explanation of an error returned by the wait3(2) system call. The least the message will contain is the value of strerror(errno), but usually it will do much better, and indicate the underlying cause in more detail.

The errno global variable will be used to obtain the error value to be decoded.

This function is intended to be used in a fashion similar to the following example:
    int pid = wait3(status, options, rusage);
    if (pid < 0)
    {
        char message[3000];
        explain_message_wait3(message, sizeof(message),
            status, options, rusage);
        fprintf(stderr, "%s\n", message);
        exit(EXIT_FAILURE);
    }

message
    The location in which to store the returned message. If a suitable message return buffer is supplied, this function is thread safe.

message_size
    The size in bytes of the location in which to store the returned message.

status
    The original status, exactly as passed to the wait3(2) system call.

options
    The original options, exactly as passed to the wait3(2) system call.

rusage
    The original rusage, exactly as passed to the wait3(2) system call.

  explain_message_errno_wait3
void explain_message_errno_wait3(char *message, int message_size, int errnum, int *status, int options, struct rusage *rusage);

The explain_message_errno_wait3 function may be used to obtain an explanation of an error returned by the wait3(2) system call. The least the message will contain is the value of strerror(errnum), but usually it will do much better, and indicate the underlying cause in more detail.

This function is intended to be used in a fashion similar to the following example:
    int pid = wait3(status, options, rusage);
    if (pid < 0)
    {
        int err = errno;
        char message[3000];
        explain_message_errno_wait3(message, sizeof(message), err,
            status, options, rusage);
        fprintf(stderr, "%s\n", message);
        exit(EXIT_FAILURE);
    }

message
    The location in which to store the returned message. If a suitable message return buffer is supplied, this function is thread safe.

message_size
    The size in bytes of the location in which to store the returned message.

errnum
    The error value to be decoded, usually obtained from the errno global variable just before this function is called. This is necessary if you need to call any code between the system call to be explained and this function, because many libc functions will alter the value of errno.

status
    The original status, exactly as passed to the wait3(2) system call.

options
    The original options, exactly as passed to the wait3(2) system call.

rusage
    The original rusage, exactly as passed to the wait3(2) system call.

SEE ALSO

wait3(2)
    wait for process to change state

explain_wait3_or_die(3)
    wait for process to change state and report errors

COPYRIGHT
libexplain version
Copyright (C) 2008 Peter Miller